#ifndef FINAL_EFFECT_H
#define FINAL_EFFECT_H

#include <string>

class FinalEffects {
    bool no_removing;
    int limited_to_value_bytes, limited_to_value_fields, limited_to_value_lines, limited_to_value_rows, wall_value;
    std::string file_name;
    unsigned char joint_byte, separator_byte;

public:
    ~FinalEffects();
    FinalEffects(std::string fn, 
      int vb, int vf, int VL, int vr, int wv, 
      unsigned char jb, unsigned char sb, 
      bool nr);

    bool noRemoving() const;
    int behindWall() const;
    int valueBytes() const;
    int valueFields() const;
    int valueLines() const;
    int valueRows() const;
    std::string fileName() const;
    unsigned char jointByte() const;
    unsigned char separatorByte() const;
    void setFileName(char *p);
    void setFileName(std::string & fn);
};

#endif // FINAL_EFFECT_H
