/*
obot C++ Version 1.09
Copyright 2019-2020 Sogaya
Reading and writing so that the first part of EXE can be represented in hexadecimal as 4D 5A, for example.

Borland C++ 5.5.1 for Win32 (BCC55)
Digital Mars Compiler Version 8.42n (DMC 8.57 [dm857c.zip] ), STLport 4.5.3
Embarcadero C++ 7.20 for Win32 (BCC101)
Embarcadero C++ 7.30 for Win32 (BCC102)
GCC 3.4.2 (mingw-special [Bloodshed Dev-C++ 4.9.9.2] )

*/
#define G_SIZE 262144 // 256 KB
#include "ErrorText.h"
#include "FinalEffect.h"
#include "Guide.h"
#include "Hexadecimal.h"
#include "HyphenTerm.h"
#include "MessagesText.h"
#include "Numbered.h"
#include "TimeName.h"

namespace {
    bool VERSION_WITH_COMMENTS = true;
    bool VERSION_WITHOUT_COMMENTS = false;
    char C_SETTING_TEXT[] = "C:\\Sjisutf8\\set_obot.txt";
    char SETTING_TEXT[] = "set_obot.txt";
    char TEMPORARY_TEXT[] = "text.tmp";
    const bool PUT_NEW_LINE = true;
    const char TAB_C = 9; // 09h
    const int COMMA_BYTE = 44; // 2Ch, ',' 
    const int FEW_LINES = 3;
    const int FINAL_INTEGER = 2147483647; // 7FFFFFFFh 
    const int FILE_ERROR = -2;
    const int GAP_BYTE = 32; // 20h, SP 
    const int H_2C = 44; // ',' 
    const int H_5F = 95; // '_' 
    const int STANDARD_BUFFER_SIZE = 640;
    const int UPPER_LIMIT_TO_FIELD_NUMBER = 20;
    const int WALL = 256;
    const int ZERO_LENGTH_ERROR = -4;
    const std::string BYTES_640("-b640");
    const std::string C_ERR = "err";
    const std::string FIELDS_20("-c20");
    const std::string LINES_3("-m3");
    const std::string PATH_NAME("C:\\Sjisutf8\\Sjisutf8.exe");
    const std::string ROWS_2147483647("-r2147483647");
    const std::string TEXT_FILE = ".txt";
    double VERSION_NUMBER = 1.09;
    int buffer_size, error_number, size;
    std::string file_name;
    std::stringstream os;
    unsigned char final_separator;
}

int main(int argc, char *argv[]) {
    using namespace std;

    bool SETTING_TEXT_IS_NOT_ACCESSIBLE;
    try {
        ifstream testFile(C_SETTING_TEXT);
        testFile.exceptions(ios_base::failbit);
        SETTING_TEXT_IS_NOT_ACCESSIBLE = false;
    } catch(...) {
        SETTING_TEXT_IS_NOT_ACCESSIBLE = true;
    }

    if( SETTING_TEXT_IS_NOT_ACCESSIBLE ) {
        try {
            ifstream testFile(SETTING_TEXT);
            testFile.exceptions(ios_base::failbit);
        } catch(...) {
// Providing SETTING_TEXT in the current directory
            ofstream newFile(SETTING_TEXT);

            newFile << PATH_NAME << endl;
            newFile << BYTES_640 << TAB_C << "bytes" << endl;
            newFile << FIELDS_20 << TAB_C << "fields" << endl;
            newFile << LINES_3 << TAB_C << "lines" << endl;
            newFile << ROWS_2147483647 << TAB_C << "rows" << endl;
        }

    }

    if( argc == 1 ) {
// Producing TEMPORARY_TEXT from standard input 
        Hexadecimals *e = new Hexadecimals(H_5F);
        e->produceTemporaryTextFile();

        ifstream testFile(TEMPORARY_TEXT, ios::binary | ios::ate );
        size = (int)testFile.tellg();
        testFile.close();

        e->setting(TEMPORARY_TEXT, size, UPPER_LIMIT_TO_FIELD_NUMBER, FEW_LINES, FINAL_INTEGER, WALL);
        e->limiting();

        remove(TEMPORARY_TEXT);

        delete e;
        return 0;
    }

// command parameters 
    bool readable_block;
    int file_name_length, readable_block_size;
    string file_name, new_name;
    ParameterList *listing = new ParameterList(argc, argv);
    HyphenTerms *h = new HyphenTerms(listing);
    h->setting();

    if( h->guideFile() ) {
        Guiding *g = new Guiding();
        g->versionGuide(VERSION_NUMBER, VERSION_WITH_COMMENTS);
        delete g; delete h;
        exit(171);
    } else if( h->versionNumber() ) {
        Guiding *g = new Guiding();
        g->versionGuide(VERSION_NUMBER, VERSION_WITHOUT_COMMENTS);
        delete g; delete h;
        exit(172);
    }

    readable_block_size = h->readableBlockSize();
    if( readable_block_size > 0 ) {
        readable_block = true;
    } else if( h->readableBlock() ) {
        readable_block = true;
        readable_block_size = G_SIZE;
    } else { 
        readable_block = false;
    }

    if( readable_block ) {
// Software may receive many lines from the standard input, and shall send a readable block to the standard output.
        Hexadecimals *e = new Hexadecimals(H_5F);
        e->setting(readable_block_size);

        if( h->skippingStandardOutput() ) {
            e->skipping_standard_output_of_readable_block();
        } else {
            e->standard_output_of_readable_block();
        }

        return 0;
    }

    file_name = h->fileName();
    h->joints(); // joint_byte 
    h->separators(); // separator_byte 
    if( h->noChecking() ) {
        final_separator = h->separatorByte();
    } else if( h->extensionEqualsCSV(file_name) ) {
        final_separator = COMMA_BYTE;
    } else {
        final_separator = h->separatorByte();
    }

    file_name_length = file_name.length();
    if( file_name_length == 0 ) {
        buffer_size = STANDARD_BUFFER_SIZE;
    } else {
        try {
            ifstream testFile( file_name.c_str(), ios::binary | ios::ate );
            testFile.exceptions(ios_base::failbit);

            size = (int)testFile.tellg();
        } catch(...) {
            size = FILE_ERROR;
            error_number = 219;
            os << "main() error-" << error_number << ": " << file_name;

            ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
            x.setting();
            exit(error_number);
        }

        if( size == 0L ) {
            size = ZERO_LENGTH_ERROR;
            error_number = 220;
            os << "file_size() error-" << error_number << ": size = " << size;

            ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
            x.setting();
            exit(error_number);
        } else if( size > h->valueBytes() ) {
            buffer_size = h->valueBytes();
        } else {
            buffer_size = size;
        }

    }

    FinalEffects *f = new FinalEffects(file_name,
      buffer_size, h->valueFields(), h->valueLines(), h->valueRows(), h->behindWall(), 
      h->jointByte(), final_separator,
      h->noRemoving() );

    if(! f->noRemoving() ) {
        if( file_name_length == 0 ) {
            remove(TEMPORARY_TEXT);
        }

    }

// main function 
    if( f->separatorByte() == GAP_BYTE ) {
        Hexadecimals *e = new Hexadecimals( f->jointByte() );

        file_name = f->fileName();
        file_name_length = file_name.length();
        if( file_name_length == 0 ) {
// Producing TEMPORARY_TEXT from standard input 
            e->produceTemporaryTextFile();
            f->setFileName(TEMPORARY_TEXT);
        }

        e->setting(f);
        e->limiting();
        delete e;
    } else {
        Hexadecimals *e = new Hexadecimals( f->jointByte(), f->separatorByte() );

        file_name = f->fileName();
        file_name_length = file_name.length();
        if( file_name_length == 0 ) {
// Producing TEMPORARY_TEXT from standard input 
            e->produceTemporaryTextFile();
            f->setFileName(TEMPORARY_TEXT);
        }

        e->setting(f);
        e->limiting_to_produce_data_file();
        delete e;
    }

// end of the main function 
    delete f; delete h;
    return 0;
}
