#ifndef PARAMETERS_H
#define PARAMETERS_H

#define C_SIZE 256
#define Q_SIZE 64
#include <iostream>
#include <string>

class CommandParameters {
    bool head_hyphen, positively_represented, small_length, tail_hyphen, with_ASCII, with_binary, with_figure, with_yen;
    char c[C_SIZE];
    int s_length;
    std::string ASCII, hyphenated_character, negative_pattern, positive_pattern, s;

public:
    ~CommandParameters();
    CommandParameters(char *a);

    bool headHyphen() const;
    bool positivelyRepresented() const;
    bool smallLength() const;
    bool tailHyphen() const;
    bool withASCII() const;
    bool withBinary() const;
    bool withFigure() const;
    bool withYen() const;
    int parameterLength() const;
    std::string commandParameter() const;
    std::string hyphenatedCharacter() const;
    std::string negativePattern() const;
    std::string positivePattern() const;
};

class ParameterList {
    CommandParameters *p[Q_SIZE];
    int item_count;

public:
    ~ParameterList();
    ParameterList(int c, char **v);

    bool character(int i) const;
    bool denied(int i) const;
    bool hyphenated(int i) const;
    bool number(int i) const;
    bool pattern(int i) const;
    bool referred(int i) const;
    bool shorter(int i) const;
    int itemCount() const;
    std::string item(int i) const;
    std::string negative(int i) const;
    std::string positive(int i) const;
    std::string represented(int i) const;
};

#endif // PARAMETERS_H
