CC        = bcc32c
LINKER    = ilink32

INCLUDE = -I"C:\BCC101\include"
LIB     = -L"C:\BCC101\lib\win32c\debug"

CFLAGS = -O2 -w 
LFLAGS = /Tpe /c /ap

TARGET = sjisutf16.exe
OBJS   = dividesjis.obj errortext.obj fieldsarray.obj finaleffect.obj guide.obj hyphenterm.obj convertwide.obj messagestext.obj numbered.obj parameters.obj pathexe.obj readwrite.obj searchbinary.obj sparseutf16.obj standardio.obj timename.obj ucombo.obj sjisutf16main.obj 
RESFILES = Sjisutf16Resource.res

ALL : $(TARGET)

convertwide.obj: ConvertWide.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c ConvertWide.cpp
dividesjis.obj: DivideSJIS.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c DivideSJIS.cpp
errortext.obj: ErrorText.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c ErrorText.cpp
fieldsarray.obj: FieldsArray.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c FieldsArray.cpp
finaleffect.obj: FinalEffect.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c FinalEffect.cpp
guide.obj: Guide.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c Guide.cpp
hyphenterm.obj: HyphenTerm.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c HyphenTerm.cpp
messagestext.obj: MessagesText.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c MessagesText.cpp
numbered.obj: Numbered.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c Numbered.cpp
parameters.obj: parameters.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c parameters.cpp
pathexe.obj: PathEXE.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c PathEXE.cpp
readwrite.obj: ReadWrite.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c ReadWrite.cpp
searchbinary.obj: SearchBinary.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c SearchBinary.cpp
sparseutf16.obj: SparseUTF16.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c SparseUTF16.cpp
standardio.obj: StandardIO.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c StandardIO.cpp
timename.obj: TimeName.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c TimeName.cpp
ucombo.obj: Ucombo.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c Ucombo.cpp
sjisutf16main.obj: Sjisutf16Main.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c Sjisutf16Main.cpp

$(TARGET): $(OBJS) $(RESFILES)
	$(LINKER) $(LFLAGS) $(LIB) $(OBJS) c0x32.obj,$(TARGET),,cw32.lib import32.lib,,$(RESFILES)
clean:
	del *.obj
	del *.tds
	del *.il*
	del *.map
