#ifndef CONVERT_WIDE_H
#define CONVERT_WIDE_H

/*
Sjisutf16
Converting the text from Shift_JIS to UTF-16
Copyright 2020 Sogaya

Borland C++ 5.5.1 for Win32 (BCC55)
Digital Mars Compiler Version 8.42n (DMC 8.57 [dm857c.zip] ), STLport 4.5.3
Embarcadero C++ 7.20 for Win32 (BCC101)
Embarcadero C++ 7.30 for Win32 (BCC102)
GCC 3.4.2 (mingw-special [Bloodshed Dev-C++ 4.9.9.2] )

*/

#define I_SIZE 224
#define Y_SIZE 4096
#include <ctype.h>
#include <fstream>
#include <iostream>
#include <stdio.h>
#include <string>
#include "ErrorText.h"
#include "FinalEffect.h"
#include "SparseUTF16.h"

typedef struct AsArray AsArray;
struct AsArray {
    wchar_t v[Y_SIZE];
    int v_length;
};

class ConvertWiden {
    AsArray a;
    bool carriage_return_appears, with_BOM;
    char *buffer;
    char *combo;
    char y[Y_SIZE];
    int beginning, buffer_size, combo_size, count, NEW_LINE_SIZE, y_length;
    std::string file_name, NEW_LINE, new_name;
    SparsePopulationUTF16 *table;
    unsigned char BELL_ASCII_KATAKANA[I_SIZE];

    int setBufferSize();
    long file_size(std::string & name);

public:
    ~ConvertWiden();
    ConvertWiden();

    AsArray produce_non_controllers_of_UTF16(char *s, int s_length);
    AsArray produce_UTF16_phrase(char *s, int s_length);
    AsArray reading_to_produce_UTF16();
    bool displayDataText();
    char copyingArrayItem(int index);
    int bufferingWriting(int comboLength);
    int lineCount() const;
    int produceBinaryFile(std::string & name, bool no_removing);
    int reading_to_produce_UTF16_CRLF(std::string & nn);
    int reading_to_produce_UTF16_LF(std::string & nn);
    int reading_to_produce_UTF16_text(std::string & nn);
    int renameBinaryFile(std::string & name, bool no_removing);
    int skipping_control_to_produce_UTF16_CRLF(std::string & nn);
    int skipping_control_to_produce_UTF16_LF(std::string & nn);
    int skipping_control_to_produce_UTF16_text(std::string & nn);
    int UTF16_phrase_size() const;
    std::string newLine() const;
    void ifErrorOccurs(int exit_code);
    void setting(FinalEffects *final_effects);
    void setting(FinalEffects *final_effects, int b);
    void setting(FinalEffects *final_effects, std::string fn);
};

#endif // CONVERT_WIDE_H
