#include "FinalEffect.h"

namespace {
    const int FIRST_LINE = 1;
    const std::string EMPTY = "";
}

FinalEffects::~FinalEffects() {
}

FinalEffects::FinalEffects() {
// std::string 
    file_name = EMPTY;
    new_name = EMPTY;
    path_name = EMPTY;

// int 
    focal_point = FIRST_LINE;

// unsigned char 
    joint_byte = 95; // 5Fh, '_' 

// bool 
    carriage_return = true;
    check_line_length = false;
    count_lines = false;
    identical_time = false;
    no_removing = false;
    no_searching = false;
    remove_0Dh = false;
    remove_controllers = false;
    selected_directory_has_priority = false;
    temporary_binary = false;
    which_table = false;
    with_BOM = false;
}

FinalEffects::FinalEffects(std::string fn, std::string nn) {
// std::string 
    file_name = fn;
    new_name = nn;
    path_name = EMPTY;

// int 
    focal_point = FIRST_LINE;

// unsigned char 
    joint_byte = 95; // 5Fh, '_' 

// bool 
    carriage_return = true;
    check_line_length = false;
    count_lines = false;
    identical_time = false;
    no_removing = false;
    no_searching = false;
    remove_0Dh = false;
    remove_controllers = false;
    selected_directory_has_priority = false;
    temporary_binary = false;
    which_table = false;
    with_BOM = false;
}

FinalEffects::FinalEffects(std::string fn, std::string nn, std::string pn, 
    int aa, 
    unsigned char jb, 
    bool cr, bool CL, bool cs, bool it, bool nr, bool ns, bool r0, bool rc, bool sd, bool tb, bool wt, bool wb) {
// string 
    file_name = fn;
    new_name = nn;
    path_name = pn;

// int 
    focal_point = aa; // at and around the point 

// unsigned char 
    joint_byte = jb;

// bool 
    carriage_return = cr;
    check_line_length = CL;
    count_lines = cs;
    identical_time = it;
    no_removing = nr;
    no_searching = ns;
    remove_0Dh = r0;
    remove_controllers = rc;
    selected_directory_has_priority = sd;
    temporary_binary = tb;
    which_table = wt;
    with_BOM = wb;
}

bool FinalEffects::carriageReturn() const {
    return carriage_return;
}

bool FinalEffects::checkLength() const {
    return check_line_length;
}

bool FinalEffects::countLines() const {
    return count_lines;
}

bool FinalEffects::identicalTime() const {
    return identical_time;
}

bool FinalEffects::noRemoving() const {
    return no_removing;
}

bool FinalEffects::noSearching() const {
    return no_searching;
}

bool FinalEffects::priority() const {
    return selected_directory_has_priority;
}

bool FinalEffects::produceTemporaryBinary() const {
    return temporary_binary;
}

bool FinalEffects::remove0Dh() const {
    return remove_0Dh;
}

bool FinalEffects::removeControllers() const {
    return remove_controllers;
}

bool FinalEffects::whichTable() const {
    return which_table;
}

bool FinalEffects::withBOM() const {
    return with_BOM;
}

int FinalEffects::atPoint() const {
    return focal_point;
}

std::string FinalEffects::fileName() const {
    return file_name;
}

std::string FinalEffects::newName() const {
    return new_name;
}

std::string FinalEffects::pathName() const {
    return path_name;
}

unsigned char FinalEffects::jointByte() const {
    return joint_byte;
}

