#ifndef FINAL_EFFECT_H
#define FINAL_EFFECT_H

#include <string>

class FinalEffects {
    bool carriage_return, check_line_length, count_lines, identical_time, no_removing, no_searching, remove_0Dh, remove_controllers, selected_directory_has_priority, temporary_binary, which_table, with_BOM;
    int focal_point;
    std::string file_name, new_name, path_name;
    unsigned char joint_byte;

public:
    ~FinalEffects();
    FinalEffects();
    FinalEffects(std::string fn, std::string nn);
    FinalEffects(std::string fn, std::string nn, std::string pn, 
      int aa, 
      unsigned char jb, 
      bool cr, bool CL, bool cs, bool it, bool nr, bool ns, bool r0, bool rc, bool sd, bool tb, bool wt, bool wb);

    bool carriageReturn() const;
    bool checkLength() const;
    bool countLines() const;
    bool identicalTime() const;
    bool noRemoving() const;
    bool noSearching() const;
    bool priority() const;
    bool produceTemporaryBinary() const;
    bool remove0Dh() const;
    bool removeControllers() const;
    bool whichTable() const;
    bool withBOM() const;
    int atPoint() const;
    std::string fileName() const;
    std::string newName() const;
    std::string pathName() const;
    unsigned char jointByte() const;
};

#endif // FINAL_EFFECT_H
