#include "ReadWrite.h"

namespace {
    char BOM[3] = {255, 254, 0}; // FFh, FEh
    char TEMPORARY_BINARY[] = "binary.tmp";
    const bool PUT_NEW_LINE = true;
    const bool REMOVE_ANCIENT_FILE = false;
    const char LF_C = 10; // 0Ah
    const char SENTINEL = 255; // FFh
    const int BOM_LENGTH = 2;
    const int EOL_LENGTH = 1;
    const int NEW_LINE_LENGTH = 2;
    const int REMOVED = -5;
    const int SIZE_OF_CHAR = 1;
    const int SIZE_OF_WCHAR_T = 2;
    const int V_SIZE_1 = V_SIZE - 1;
    const std::string C_ERR = "err";
    const std::string EMPTY = "";
    const std::string TEXT_FILE = ".txt";
    wchar_t EOL[2] = {10, 0}; // end of line
    wchar_t NEW_LINE[3] = {13, 10, 0}; // 0Dh, 0Ah
}

ReadingWriting::~ReadingWriting() {
    delete c;
}

ReadingWriting::ReadingWriting(FinalEffects *final_effects, char *nn) {
    f = final_effects;
    with_BOM = f->withBOM();
    file_name = f->fileName();
    strcpy(new_name, nn);

    c = new ConvertWiden();
    c->setting(f);
}

bool ReadingWriting::setting() {
    using namespace std;

    bool software_can_open_file;
    int error_number;
    stringstream os;

    try {
        ifstream testFile( file_name.c_str(), ios::binary );
        testFile.exceptions(ios_base::failbit);
        software_can_open_file = true;
    } catch(...) {
        software_can_open_file = false;
        error_number = 283;
        os << "ReadingWriting::setting() error-" << error_number << ": " << file_name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    if( f->identicalTime() ) {
        c->produceBinaryFile(file_name, REMOVE_ANCIENT_FILE);
        c->renameBinaryFile( file_name, f->noRemoving() );
    }

    return software_can_open_file;
}

int ReadingWriting::checking_length_to_produce_UTF16_CRLF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");
    FILE *sjisFile = fopen( file_name.c_str(), "rt");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        v[V_SIZE_1] = SENTINEL;

        p = fgets(v, V_SIZE, sjisFile);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\n');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        if( v[V_SIZE_1] == '\0' ) {
            fprintf(stderr, "Warning: full buffer ( Line-%d )\n", count);
        }

        a = c->produce_UTF16_phrase(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(NEW_LINE, SIZE_OF_WCHAR_T, NEW_LINE_LENGTH, utf16File);
    }

    fclose(sjisFile);
    fclose(utf16File);
    return count;
}

int ReadingWriting::checking_length_to_produce_UTF16_LF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");
    FILE *sjisFile = fopen( file_name.c_str(), "rb");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        v[V_SIZE_1] = SENTINEL;

        p = fgets(v, V_SIZE, sjisFile);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\r');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        if( v[V_SIZE_1] == '\0' ) {
            fprintf(stderr, "Warning: full buffer ( Line-%d )\n", count);
        }

        a = c->produce_UTF16_phrase(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(EOL, SIZE_OF_WCHAR_T, EOL_LENGTH, utf16File);
    }

    fclose(sjisFile);
    fclose(utf16File);
    return count;
}

int ReadingWriting::checking_skipping_control_to_produce_UTF16_CRLF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");
    FILE *sjisFile = fopen( file_name.c_str(), "rt");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        v[V_SIZE_1] = SENTINEL;

        p = fgets(v, V_SIZE, sjisFile);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\n');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        if( v[V_SIZE_1] == '\0' ) {
            fprintf(stderr, "Warning: full buffer ( Line-%d )\n", count);
        }

        a = c->produce_non_controllers_of_UTF16(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(NEW_LINE, SIZE_OF_WCHAR_T, NEW_LINE_LENGTH, utf16File);
    }

    fclose(sjisFile);
    fclose(utf16File);
    return count;
}

int ReadingWriting::checking_skipping_control_to_produce_UTF16_LF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");
    FILE *sjisFile = fopen( file_name.c_str(), "rb");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        v[V_SIZE_1] = SENTINEL;

        p = fgets(v, V_SIZE, sjisFile);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\r');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        if( v[V_SIZE_1] == '\0' ) {
            fprintf(stderr, "Warning: full buffer ( Line-%d )\n", count);
        }

        a = c->produce_non_controllers_of_UTF16(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(EOL, SIZE_OF_WCHAR_T, EOL_LENGTH, utf16File);
    }

    fclose(sjisFile);
    fclose(utf16File);
    return count;
}

int ReadingWriting::countLines(std::string & name) {
    using namespace std;

    int block_has_been_read, count, error_number;
    stringstream os;

    try {
        ifstream testFile( name.c_str() );
        testFile.exceptions(ios_base::failbit);
    } catch(...) {
        error_number = 284;
        os << "countLines() error-" << error_number << ": " << name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    ifstream nameFile( name.c_str(), ios::binary);
    count = 0;
    for(;;) {
        nameFile.read(y, Y_SIZE);
        block_has_been_read = nameFile.gcount();
        if( block_has_been_read == 0 ) {
            break;
        }

        for(int i = 0; i < block_has_been_read; ++i) {
            if( y[i] == LF_C ) {
                count += 1;
            }

        }

    }

    return count;
}

int ReadingWriting::lineCount() const {
    return count;
}

int ReadingWriting::reading_to_produce_UTF16_CRLF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");
    FILE *sjisFile = fopen( file_name.c_str(), "rt");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        p = fgets(v, V_SIZE, sjisFile);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\n');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        a = c->produce_UTF16_phrase(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(NEW_LINE, SIZE_OF_WCHAR_T, NEW_LINE_LENGTH, utf16File);
    }

    fclose(sjisFile);
    fclose(utf16File);
    return count;
}

int ReadingWriting::reading_to_produce_UTF16_LF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");
    FILE *sjisFile = fopen( file_name.c_str(), "rb");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        p = fgets(v, V_SIZE, sjisFile);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\r');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        a = c->produce_UTF16_phrase(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(EOL, SIZE_OF_WCHAR_T, EOL_LENGTH, utf16File);
    }

    fclose(sjisFile);
    fclose(utf16File);
    return count;
}

int ReadingWriting::renameBinaryFile(std::string & name, bool no_removing) {
    using namespace std;

    char c[C_SIZE];
    int block_has_been_read, error_number;
    int sum = 0;
    stringstream os;

    try {
        ifstream testFile(TEMPORARY_BINARY);
        testFile.exceptions(ios_base::failbit);
    } catch(...) {
        error_number = 285;
        os << "renameBinaryFile() error-" << error_number << ": " << name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    if( no_removing ) {
        ifstream nameFile(TEMPORARY_BINARY, ios::binary);
        ofstream newFile( name.c_str(), ios::binary );

        for(;;) {
            nameFile.read(y, Y_SIZE);
            block_has_been_read = nameFile.gcount();
            if( block_has_been_read == 0 ) {
                break;
            }

            newFile.write(y, block_has_been_read);
            sum += block_has_been_read;
        }

    } else {
        strcpy(c, name.c_str() );
        if( rename(TEMPORARY_BINARY, c) ) {
            remove(c);
            sum = REMOVED;
            rename(TEMPORARY_BINARY, c);
        }

    }

    return sum;
}

int ReadingWriting::skipping_control_to_produce_UTF16_CRLF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");
    FILE *sjisFile = fopen( file_name.c_str(), "rt");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        p = fgets(v, V_SIZE, sjisFile);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\n');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        a = c->produce_non_controllers_of_UTF16(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(NEW_LINE, SIZE_OF_WCHAR_T, NEW_LINE_LENGTH, utf16File);
    }

    fclose(sjisFile);
    fclose(utf16File);
    return count;
}

int ReadingWriting::skipping_control_to_produce_UTF16_LF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");
    FILE *sjisFile = fopen( file_name.c_str(), "rb");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        p = fgets(v, V_SIZE, sjisFile);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\r');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        a = c->produce_non_controllers_of_UTF16(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(EOL, SIZE_OF_WCHAR_T, EOL_LENGTH, utf16File);
    }

    fclose(sjisFile);
    fclose(utf16File);
    return count;
}

int ReadingWriting::standard_input_checking_to_produce_UTF16_CRLF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        v[V_SIZE_1] = SENTINEL;

        p = fgets(v, V_SIZE, stdin);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\n');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        if( v[V_SIZE_1] == '\0' ) {
            fprintf(stderr, "Warning: full buffer ( Line-%d )\n", count);
        }

        a = c->produce_UTF16_phrase(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(NEW_LINE, SIZE_OF_WCHAR_T, NEW_LINE_LENGTH, utf16File);
    }

    fclose(utf16File);
    return count;
}

int ReadingWriting::standard_input_checking_skipping_to_produce_UTF16_CRLF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        v[V_SIZE_1] = SENTINEL;

        p = fgets(v, V_SIZE, stdin);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\n');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        if( v[V_SIZE_1] == '\0' ) {
            fprintf(stderr, "Warning: full buffer ( Line-%d )\n", count);
        }

        a = c->produce_non_controllers_of_UTF16(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(NEW_LINE, SIZE_OF_WCHAR_T, NEW_LINE_LENGTH, utf16File);
    }

    fclose(utf16File);
    return count;
}

int ReadingWriting::standard_input_reading_to_produce_UTF16_CRLF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        p = fgets(v, V_SIZE, stdin);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\n');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        a = c->produce_UTF16_phrase(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(NEW_LINE, SIZE_OF_WCHAR_T, NEW_LINE_LENGTH, utf16File);
    }

    fclose(utf16File);
    return count;
}

int ReadingWriting::standard_input_skipping_to_produce_UTF16_CRLF() {
    char *p;
    FILE *utf16File = fopen(new_name, "wb");

    if( with_BOM ) {
        fwrite(BOM, SIZE_OF_CHAR, BOM_LENGTH, utf16File);
    }

    count = 0;
    for(;;) {
        p = fgets(v, V_SIZE, stdin);
        if(p == NULL) {
            break;
        } else {
            p = strchr(v, '\n');
            if(p != NULL) {
                *p = '\0';
            }

        }

        count += 1;
        a = c->produce_non_controllers_of_UTF16(v, strlen(v) );
        fwrite(a.v, SIZE_OF_WCHAR_T, a.v_length, utf16File);
        fwrite(NEW_LINE, SIZE_OF_WCHAR_T, NEW_LINE_LENGTH, utf16File);
    }

    fclose(utf16File);
    return count;
}

