#ifndef SPARSE_UTF16_H
#define SPARSE_UTF16_H

/*
K
FC4Bh

FC4Ch = 64588
64588 * ( UTF16_KANJI_SIZE + 1 ) = 258352 < Z_SIZE

*/
#define E_SIZE 4
#define U_SIZE 182234
#define Y_SIZE 4096
#define Z_SIZE 261073
#include "ErrorText.h"
#include "FinalEffect.h"
#include "MessagesText.h"
#include "PathEXE.h"
#include "SearchBinary.h"

typedef std::string (*OpenCloseFunction)();

class SparsePopulationUTF16 {
    char *z;
    char a[E_SIZE];
    OpenCloseFunction open_close[5];
    wchar_t UTF16_CHAR[U_SIZE];

public:
    ~SparsePopulationUTF16();
    SparsePopulationUTF16();

    bool setting(std::string BINARY_TABLE);
    bool setting(SearchTable *e);
    bool setting(FinalEffects *f);
    char working(int index, int place);
    void clear();
    void populated(int index, int place, char c);
    wchar_t UTF16Char(int index);
};

#endif // SPARSE_UTF16_H
