#ifndef SPARSE_UTF8_H
#define SPARSE_UTF8_H

/*
K
FC4Bh

FC4Ch = 64588
64588 * ( UTF8_KANJI_SIZE + 1 ) = 258352 < Z_SIZE

*/
#define A_SIZE 5
#define Y_SIZE 4096
#define Z_SIZE 261073
#include "ErrorText.h"
#include "FinalEffect.h"
#include "MessagesText.h"
#include "PathEXE.h"
#include "SearchBinary.h"

typedef std::string (*OpenCloseFunction)();

class SparsePopulationUTF8 {
    char *z;
    char a[A_SIZE];
    OpenCloseFunction open_close[5];

public:
    ~SparsePopulationUTF8();
    SparsePopulationUTF8();

    bool setting(std::string BINARY_TABLE);
    bool setting(SearchTable *e);
    bool setting(FinalEffects *f);
    char working(int index, int place);
    void clear();
    void populated(int index, int place, char c);
};

#endif // SPARSE_UTF8_H
