#ifndef STANDARD_IO_H
#define STANDARD_IO_H

#define I_SIZE 224
#define Y_SIZE 4096
#include <fstream>
#include <iostream>
#include <stdio.h>
#include <string>
#include "ErrorText.h"
#include "FinalEffect.h"
#include "SearchBinary.h"
#include "SparseUTF8.h"

class StandardInput {
    bool carriage_return_appears;
    char *buffer;
    char *combo;
    char y[Y_SIZE];
    int beginning, buffer_size, combo_size, count, NEW_LINE_SIZE, y_length;
    std::string file_name, NEW_LINE, new_name;
    SparsePopulationUTF8 *table;
    unsigned char BELL_ASCII_KATAKANA[I_SIZE];

    int setBufferSize();
    long file_size(std::string & name);

public:
    ~StandardInput();
    StandardInput();

    bool displayDataText();
    int bufferingWriting(int comboLength);
    int lineCount() const;
    int produceBinaryFile(std::string & name, bool no_removing);
    int produceTemporaryTextFile();
    int renameBinaryFile(std::string & name, bool no_removing);
    int standard_input();
    int standard_input_of_non_controllers();
    std::string newLine() const;
    void ifErrorOccurs(int exit_code);
    void setting(FinalEffects *final_effects);
    void setting(FinalEffects *final_effects, int b);
    void setting(SearchTable *search_table);
};

#endif // STANDARD_IO_H
