#ifndef FINAL_EFFECT_H
#define FINAL_EFFECT_H

#include <string>

class FinalEffects {
    bool carriage_return, check_line_length, count_lines, identical_time, no_removing, remove_0Dh, temporary_binary, with_BOM;
    int focal_point;
    std::string file_name, new_name, path_name;
    unsigned char joint_byte;

public:
    ~FinalEffects();
    FinalEffects(std::string fn, std::string nn, std::string pn, 
      int fp, 
      unsigned char jb, 
      bool cr,  bool CL, bool cs, bool it, bool nr, bool r0, bool tb, bool wb);

    bool carriageReturn() const;
    bool checkLength() const;
    bool countLines() const;
    bool identicalTime() const;
    bool include0Dh() const;
    bool noRemoving() const;
    bool produceTemporaryBinary() const;
    bool remove0Dh() const;
    bool withBOM() const;
    int focalPoint() const;
    std::string fileName() const;
    std::string newName() const;
    std::string pathName() const;
    unsigned char jointByte() const;
    void setFileName(std::string & f);
};

#endif // FINAL_EFFECT_H
